import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { RPCService } from '@loafer/ng-rpc';

import { Notification } from '@overflow/commons-typescript/model/notification';
import { Member } from '@overflow/commons-typescript/model/member';
import { Page, PageParams } from '@overflow/commons-typescript/core/model';

@Injectable()
export class NotificationService {

  public constructor(
    private rpcService: RPCService,
  ) {

  }

  public readAllByMemberEmail(memberEmail: string, pageParams: PageParams): Observable<Page<Notification>> {
    return this.rpcService.call('NotificationService.readAllByMemberEmail', memberEmail, pageParams);
  }

  public markAllAsReadByMemberEmail(memberEmail: string, pageParams: PageParams): Observable<Page<Notification>> {
    return this.rpcService.call('NotificationService.markAllAsReadByMemberEmail',  memberEmail, pageParams);
  }

  public markAsRead(notificationID: number): Observable<Notification> {
    return this.rpcService.call('NotificationService.markAsRead', notificationID);
  }

}
